// SPDX-License-Identifier: LGPL-3.0-or-later
// Copyright © 2020 Florian Schmaus
#include "Dispatcher.hpp"

#include <pthread.h>	// for pthread_yield

#include "Emper.hpp"
#include "Runtime.hpp"	// for Runtime

thread_local const Fiber* Dispatcher::currentFiber;

auto Dispatcher::getDispatchLoop() -> func_t {
	return [this] { dispatchLoop(); };
}

void Dispatcher::putRuntimeWorkerToSleep() { runtime.dispatcherLoopSleep(); }

void Dispatcher::dispatchLoopDoSleep() {
	if constexpr (emper::WORKER_SLEEP) {
		putRuntimeWorkerToSleep();
	} else {
		pthread_yield();
	}
}
