// SPDX-License-Identifier: LGPL-3.0-or-later
// Copyright © 2020 Florian Schmaus
#include "Scheduler.hpp"

#include "Runtime.hpp"

Scheduler::Scheduler(Runtime& runtime) : runtime(runtime) {}

void Scheduler::addNewWorkerHook(const std::function<void(void)>& hook) {
	runtime.addNewWorkerHook(hook);
}

void Scheduler::wakeupSleepingWorkersIfSleepingObserved() {
	runtime.wakeupSleepingWorkers<WakeupMode::IF_SLEEPING_OBSERVED>();
}

void Scheduler::wakeupSleepingWorkersAlways() {
	runtime.wakeupSleepingWorkers<WakeupMode::ALWAYS>();
}
