// SPDX-License-Identifier: LGPL-3.0-or-later
// Copyright © 2020 Florian Schmaus
#include "DebugUtil.hpp"

#include <execinfo.h>
#include <unistd.h>

#include <csignal>
#include <cstdio>
#include <cstdlib>

static void handler(int sig) {
	const int backtrace_size = 20;
	// NOLINTNEXTLINE(modernize-avoid-c-arrays)
	void* array[backtrace_size];

	size_t size = backtrace(array, backtrace_size);

	fprintf(stderr, "Error: signal %d:\n", sig);
	backtrace_symbols_fd(array, size, STDERR_FILENO);
	exit(EXIT_FAILURE);
}

void enableStacktraceOnAborts() {
	signal(SIGSEGV, handler);
	signal(SIGABRT, handler);
}
