// SPDX-License-Identifier: LGPL-3.0-or-later
// Copyright © 2020 Florian Schmaus
#include "WsDispatcher.hpp"

#include "Runtime.hpp"	// for Runtime

class Fiber;

void WsDispatcher::dispatchLoop() {
	while (true) {
		const Fiber* fiber = runtime.nextFiber();
		if (!fiber) {
			dispatchLoopDoSleep();

			continue;
		}

		dispatch(fiber);

		recycle(fiber);
	}
}
