// SPDX-License-Identifier: LGPL-3.0-or-later
// Copyright © 2020 Florian Schmaus
#include "WsStrategy.hpp"

#include "WsDispatcher.hpp"
#include "WsScheduler.hpp"
#include "strategies/ws/WsStrategyStats.hpp"	// for WsStrategyStats

class Runtime;
class RuntimeStrategyStats;

WsStrategy WsStrategy::INSTANCE;

auto WsStrategy::getScheduler(Runtime& runtime) -> Scheduler& {
	Scheduler* scheduler = new WsScheduler(runtime, *this);
	return *scheduler;
}

auto WsStrategy::getDispatcher(Runtime& runtime) -> Dispatcher& {
	Dispatcher* dispatcher = new WsDispatcher(runtime);
	return *dispatcher;
}

auto WsStrategy::getStats() -> std::shared_ptr<RuntimeStrategyStats> {
	return std::make_shared<WsStrategyStats>(*this);
}
