// SPDX-License-Identifier: LGPL-3.0-or-later
// Copyright © 2020 Florian Schmaus
#include "WsStrategyStats.hpp"

#include <atomic>
#include <iostream>

#include "WsStrategy.hpp"

WsStrategyStats::WsStrategyStats(WsStrategy& wsStrategy)
		: scheduledFibers(wsStrategy.scheduledFibers),
			nextFiberFromLocal(wsStrategy.nextFiberFromLocal),
			nextFiberStolen(wsStrategy.nextFiberStolen) {}

auto WsStrategyStats::getScheduledFibers() const -> uint64_t { return scheduledFibers; }

auto WsStrategyStats::getNextFiberFromLocal() const -> uint64_t { return nextFiberFromLocal; }

auto WsStrategyStats::getNextFiberStolen() const -> uint64_t { return nextFiberStolen; }

void WsStrategyStats::print() {
	std::cout << "WsStrategyStats"
						<< " scheduledFibers:" << scheduledFibers
						<< " nextFiberFromLocal:" << nextFiberFromLocal
						<< " nextFiberStolen:" << nextFiberStolen << std::endl;
}
